/*
 * Desenvolvido para a disciplina Programacao 1
 * Curso de Bacharelado em Cincia da Computao
 * Departamento de Sistemas e Computao
 * Universidade Federal da Paraba
 *
 * Copyright (C) 1999 Universidade Federal da Paraba.
 * No redistribuir sem permisso.
 */
package p1.aplic.banco;

import p1.aplic.geral.*;

/**
 * Classe de conta bancria simples para pessoa fsica.
 *
 * @author   Jacques Philippe Sauv, jacques@dsc.ufpb.br
 * @version 1.1
 * <br>
 * Copyright (C) 1999 Universidade Federal da Paraba.
 */
public class ContaSimples extends Conta {
	// construtores
	/**
	 * Cria uma conta a partir de uma pessoa e nmero de conta.
	 * @param titular O titular da conta.
	 * @param nmero O nmero da conta.
	 */
	public ContaSimples(Pessoa titular, int nmero) {
		super(titular, nmero);
		Agencia.addTitular(titular);
		Agencia.addConta(this);
	}

	/**
	 * Cria uma conta a partir de um nome e cpf de pessoa fsica, e um nmero de conta.
	 * @param nome O nome do titular da conta.
	 * @param cpf O CPF do titular da conta.
	 * @param nmero O nmero da conta.
	 */
	/* Este mtodo existe para esconder a classe Pessoa dos principiantes */
	public ContaSimples(String nome, String cpf, int nmero) {
		this(new Pessoa(nome, cpf), nmero);
	}

	/**
	 * Transforma os dados da conta em um String.
	 * @return O string com os dados da conta.
	 */
	public String toString() {
		return "ContaSimples " + super.toString();
	}
}
