/*
 * Desenvolvido para a disciplina Programacao 2
 * Curso de Bacharelado em Cincia da Computao
 * Departamento de Sistemas e Computao
 * Universidade Federal da Paraba
 *
 * Copyright (C) 2001 Universidade Federal da Paraba.
 * No redistribuir sem permisso.
 */
 
package p1.aplic.mancala.jogo;
import java.util.*;

/**
 * A parte comum de qualquer jogador: manter nome e posio (EM_BAIXO ou EM_CIMA).
 *
 * @author   Jacques Philippe Sauv, jacques@dsc.ufpb.br
 * @version 1.0
 * <br>
 * Copyright (C) 2001 Universidade Federal da Paraba.
 */
public abstract class JogadorAbstrato implements Jogador {
  private String nome;
  private int posio;

  /**
   * Construtor genrico de um jogador.
   *
   * @param   nome   O nome do jogador.
   * @param   posio   A posio do jogador (EM_BAIXO ou EM_CIMA).
   */
  public JogadorAbstrato(String nome, int posio) {
    this.nome = nome;
    this.posio = posio;
  }

  /**
   * Obtm o nome do jogador.
   *
   * @return  O nome do jogador
   */
  public String getNome() {
    return nome;
  }

  /**
   * Informa a posio do jogador.
   *
   * @return  A posio do jogador (EM_BAIXO ou EM_CIMA)
   */
  public int getPosio() {
    return posio;
  }

  /**
   * Pede ao jogador para escolher um buraco para jogar.
   *
   * @param   jogo   O jogo do qual o jogador est participando.
   * @return  O nmero do buraco (entre 0 e 5)
   * @throws  MancalaException se o buraco escolhido no for possvel.
   */
  public abstract int escolheJogada(JogoMancala jogo) throws MancalaException;
}

